c2345678901234567

      program cart2esf
      implicit double precision (a-h,o-z)
c ------------------------------------------------------------
c               (x,y,z) ---->|cart2esf| ---> (r, alfa, delta)
c                                               in degrees
c     Example:
c             Execute: echo "1 0 0"|cart2esf
c
c      @gAGE (Research group of Astronomy and GEomatics). UPC
c ------------------------------------------------------------

        pi=3.1415926535898d0

10      continue
        read (*,*,end=100) x,y,z
        r=dsqrt(x**2+y**2+z**2)
        alfa=datan2(y,x)
        if (alfa.lt.0.d0) alfa=alfa+2.d0*pi
        delta=datan2(z,dsqrt(x**2+y**2))
        print *, r, alfa*180.d0/pi, delta*180.d0/pi
        goto 10

100     continue
        end

c       f77 -o cart2esf cart2esf.f
