c234567
      implicit double precision (a-h,o-z)

c ------------------------------------------------------------
c
c       (r, alfa, delta)  ---->|esf2cart| ---> (x,y,z)
c          in degrees
c     Example:
c          Execute: echo "1 90 90"|esf2cart
c
c      @gAGE (Research group of Astronomy and GEomatics). UPC
c ------------------------------------------------------------

        pi=3.1415926535898d0

10      continue

        read (*,*,end=100) r,a,d

        a=a*pi/180.d0
        d=d*pi/180.d0

        x=r*dcos(a)*dcos(d)
        y=r*dsin(a)*dcos(d)
        z=r*dsin(d)
        write(*,'(f16.9,1x,f16.9,1x,f16.9)') x,y,z
        goto 10

100     continue
        end



c       f77 -o  esf2cart esf2cart.f
