c234567
      program  readrnx
      implicit double precision (a-h,o-z)
      character line*80,dtype(12)*2,fmtlp*70,sta*4,fmtsat*70,
     * tipo(150)*1
      integer c1,p2,p1,d1,d2
      dimension vtmp(8),isat(150),ias(8),isn(8)
      parameter(c=299792458.d0,f0=10.23D+6)

c ------------------------------------------------------------
c     This program reads a RINEX measuremet file and writes 
c     the measuremets in collums (one row for each satellite).
c
c      @gAGE (Research group of Astronomy and GEomatics). UPC
c ------------------------------------------------------------

c       Initialization --------------------------------
        l1=0
        l2=0
        c1=0
        p1=0
        p2=0
        d1=0
        d2=0
        f1=154.d0*f0
        f2=120.d0*f0
c       -----------------------------------------------


10      read(*,'(a)',end=1000,err=100) line

        if(line(1:11).eq."END OF FILE") goto 1000

c       ...................................................
        if(line(61:79).eq."# / TYPES OF OBSERV")then
         read(line,*)ntypes
         read(line,*)vtemp,(dtype(i),i=1,ntypes)
         do i=1,ntypes
          if(dtype(i).eq."L1")l1=i
          if(dtype(i).eq."L2")l2=i
          if(dtype(i).eq."P2")p2=i
          if(dtype(i).eq."C1")c1=i
          if(dtype(i).eq."P1")p1=i
          if(dtype(i).eq."D1")d1=i  
          if(dtype(i).eq."D2")d2=i  
         enddo
         write(fmtlp,'(a,i1,a)') '(',ntypes,'(f14.3,2i1))'
        endif
c       ...................................................

        ksat=0
        read(line(1:32),'(5(1x,i2),1x,f10.6,2(1x,i2))',
     *    err=100) iyy,mm,iday,ixh,ixm,xs,itmp1,ksat
        write(fmtsat,'(a,i2.2,a)') '(',ksat,'(a,i2))'
        read(line(33:80),fmtsat,err=100)(tipo(i),isat(i),i=1,ksat)

        do i=1,ksat
         if (ntypes.le.5) then
           read(*,fmtlp,err=100)(vtmp(j),ias(j),isn(j),j=1,ntypes)
          else
           read(*,fmtlp,err=100)(vtmp(j),ias(j),isn(j),j=1,5)
           read(*,fmtlp,err=100)(vtmp(j),ias(j),isn(j),j=6,ntypes)
         endif
60       continue
         is=isat(i)
         if ((tipo(i).eq."S").or.(tipo(i).eq."s")) is=is+100

         xl1=0.d0
         isn1=0
         if (l1.gt.0) then 
           xl1=vtmp(l1)*c/f1
           isn1=isn(l1)
         endif 
         xl2=0.d0
         isn2=0
         if (l2.gt.0) then
           xl2=vtmp(l2)*c/f2
           isn2=isn(l2)
         endif

         xc1=0.d0
         if (c1.gt.0) xc1=vtmp(c1)
         xp1=0.d0
         if (p1.gt.0) xp1=vtmp(p1)
         xp2=0.d0
         if (p2.gt.0) xp2=vtmp(p2)
         xd1=0.d0
         if (d1.gt.0) xd1=vtmp(d1)
         xd2=0.d0
         if (d2.gt.0) xd2=vtmp(d2)

         if (iyy.ge.80) then
            iyear=iyy+1900
           else
            iyear=iyy+2000
         endif

         write(*,70) is,iyear,mm,iday,ixh,ixm,xs,xl1,xl2,
     *                 xc1,xp1,xp2,xd1,xd2,isn1,isn2
70       format(i3,1x,i4,1x,4(i2,1x),f5.2,5(1x,f13.3),
     *    2(1x,f10.3),2(1x,i2))
       enddo

100    continue
       goto 10

1000  continue
      end


c     f77 -o readrnx readrnx.f
